## altos 1.9.11

=== src/easymini-v3.0/Makefile ===
#
# AltOS build
#
#

include ../lpc/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	lpc.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_boot_chain.c \
	ao_romconfig.c \
	ao_product.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_report.c \
	ao_ignite.c \
	ao_flight.c \
	ao_kalman.c \
	ao_sample.c \
	ao_data.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_task.c \
	ao_log.c \
	ao_log_mini.c \
	ao_cmd.c \
	ao_config.c \
	ao_timer_lpc.c \
	ao_exti_lpc.c \
	ao_usb_lpc.c \
	ao_spi_lpc.c \
	ao_adc_lpc.c \
	ao_beep_lpc.c \
	ao_m25.c \
	ao_ms5607.c

PRODUCT=EasyMini-v3.0
PRODUCT_DEF=-DEASYMINI_V_3_0
IDPRODUCT=0x0026

CFLAGS = $(PRODUCT_DEF) $(LPC_CFLAGS)

PROGNAME=easymini-v3.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_easymini.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

load: $(PROG)
	lpc-load $(PROG)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== debian/changelog ===
altos (1.9.11-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * capture odd changes from production machine?
  * fix version in 1.9.10 release notes
  * fix version in 1.9.10 release notes
  * need to capture .bin file for telebt loader, too
  * doc: add an appendix on frequency calibration to the all-in-one manual
  * need to capture .bin file for telebt loader, too
  * need to save .bin for TeleGPS v2.0
  * dial it down a bit more to not exceed +10 dBm, or 10 mW
  * use correct test script for v1.0 easymega
  * doc: add an appendix with examples for configurable pyro channels
  * releasing 1.9.11

  [ Keith Packard ]
  * altosdroid: Skip map draw before transform is set
  * altosdroid: Fix tab updates on Android 11 after rotate
  * Version 1.9.10.1
  * micropeak: detect empty log received from device
  * ao-tools/ao-test-igniter: Deal with devices that use both 'apogee' for ADC
  * altos/attiny: Switch to avrisp2 for development programmer
  * altos: Switch all tick variables to AO_TICK_TYPE/AO_TICK_SIGNED
  * altosdroid: Add BLUETOOTH_CONNECT permission, handle its lack
  * Version 1.9.10.2
  * data_interval == 0 means no data collection
  * altos: AES code was storing bytes in an int array
  * ao_pyro: Move delay_done out of pyro structure
  * Switch from AdoptOpenJDK to Adoptium
  * libaltos: Build Mac OSX libaltos.dylib for arm64 too
  * Version 1.9.10.3
  * altos: Re-enable apogee delay
  * altos/attiny: Eliminate warnings from -Wconversion
  * altos/drivers: Add explicit casts in ao_aprs, ao_bmx160 and ao_btm
  * altos/drivers/ao_button: Save all 32-bits of irq status
  * drivers: Fix type of radio timeout parameter
  * ao_gps_skytrac, ao_gps_ublox: Add explicit casts to quiet -Wconversion
  * ao_companion: Make time conversion to 16-bits in companion protocol explicit
  * ao_hmc5883: Add explicit casts for -Wconversion
  * drivers/ao_lco: Fix box types to be uint16_t. Also clean other -Wconversion messages
  * drivers: Resolve -Wconversion in m25, mma655x, mmc5983, mpu and ms5607
  * drivers/ao_packet: Switch time values to AO_TICK_TYPE
  * drivers/ao_pad: Convert from/to 16-bit times over the air
  * drivers/ao_quadrature: Fix -Wconversion warnings
  * drivers/ao_rn4678: Fix timeouts to use AO_TICK_TYPE
  * altos: Switch ao_radio_recv timeout to AO_TICK_TYPE
  * altos/ao_stdio: use uint8_t for stdio index
  * altos/ao_freq: Use uint32_t for radio freq setting value
  * beep, cmd, config, convert_volt, data, distance, fec, kalman: -Wconversion warnings
  * fifo: Add casts to fifo operation macros for -Wconversion
  * ao_companion: Make motor_number uint16_t
  * ao_convert_pa: Switch array index to unsigned type
  * ao_flight: ao_interval_end type was too small, could cause premature landing state
  * ao_gps, ao_log: Make conversions to 16-bit time log values explicit
  * ao_log: Change flight type to uint16_t, widen APIs dealing with flight numbers to int32_t
  * more 16-bit log tick values
  * ao_log: Fix sensor time triggers to use AO_TICK_TYPE
  * ao_log: Add casts to reduce -Wconversion warnings
  * ao_micro: Add casts to micropeak code for -Wconversion warnings
  * ao_radio_cmac: Make recv timeouts AO_TICK_TYPE
  * ao_radio_cmac_cmd: Clean up types for -Wconversion
  * ao_monitor: Clean up -Wconversion warnings
  * kalman, report, romconfig, sample, send_packet: Clean up -Wconversion warnings
  * ao_serial: Change serial_sleep_for APIs to use AO_TICK_TYPE
  * ao_task: Task ids are 8-bits, fix type in struct ao_task
  * ao_telemetry: Switch time variables to AO_TICK_TYPE
  * ao_telemetry: Use int16_t types for telemetry packet intervals
  * ao_telemetry: Add casts to reduce -Wconversion warnings
  * ao_tracker: Fix tracker_interval type to match config type (plus -Wconversion)
  * altos/lpc: Add casts to reduce -Wconversion warnings
  * altos/micropeak-v2.0: Add casts to reduce -Wconversion warnings
  * ao_flash_task: Add casts to reduce -Wconversion warnings
  * ao_micropeak.c: Add casts to reduce -Wconversion warnings
  * altos/stm: Add casts to reduce -Wconversion warnings
  * altos/stm32l0: Add casts to reduce -Wconversion warnings
  * altos/stmf0: Add casts to reduce -Wconversion warnings. Use AO_TICK_TYPE
  * altos/telefire: Add cast to AO_LED_CONTINUITY to eliminate -Wconversion warning
  * telefireone-v1.0: Use a boolean value for ao_log_running
  * ao_lco_v2: Use int32_t for temporary box value in step_box
  * ao_lco_v2: Add casts to reduce -Wconversion warnings
  * altos/telemega-v5.0: Add casts to beep values
  * altos: Add -Wconversion
  * altos: Deal with 8-character version numbers
  * altos: Document how delay_done is used in ao_pyro.c
  * Version 1.9.10.4
  * Allow TX power to be limited to 10mW
  * ao-telem: Read from stdin if no filenames
  * telegps-v0.3: Reduce stack size to fit in ram
  * ao-tools/ao-eeprom: Dump converted info for F packets
  * lpc: ADC 5 was busted
  * lpc: Make beeper configurable
  * src: Add easymini-v3.0
  * doc: Document 10mw limit configuration
  * doc: Add release notes for 1.9.11
  * doc: Update copyrights to 2022
  * Version 1.9.11

 -- Bdale Garbee <bdale@gag.com>  Sun, 29 May 2022 21:09:27 -0600

## altos 1.9.12

=== src/Makefile ===
#
# AltOS build
#

vpath make-altitude util
vpath make-altitude-pa util
vpath make-kalman util
vpath make-whiten util
vpath kalman.5c kalman
vpath kalman_filter.5c kalman
vpath kalman_micro.5c kalman
vpath load_csv.5c kalman
vpath matrix.5c kalman

TOPDIR=.

include Makedefs

ARMM3DIRS=\
	easymega-v1.0 easymega-v1.0/flash-loader \
	easymega-v2.0 easymega-v2.0/flash-loader \
	easymotor-v3 easymotor-v3/flash-loader \
	easytimer-v1 easytimer-v1/flash-loader \
	telemega-v0.1 telemega-v0.1/flash-loader \
	telemega-v1.0 telemega-v1.0/flash-loader \
	telemega-v2.0 telemega-v2.0/flash-loader \
	telemega-v3.0 telemega-v3.0/flash-loader \
	telemega-v4.0 telemega-v4.0/flash-loader \
	telemega-v5.0 telemega-v5.0/flash-loader \
	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
	telemetrum-v3.0 telemetrum-v3.0/flash-loader \
	telegps-v0.3 telegps-v0.3/flash-loader \
	telegps-v1.0 telegps-v1.0/flash-loader \
	telegps-v2.0 telegps-v2.0/flash-loader \
	telelco-v0.2 telelco-v0.2/flash-loader \
	telelco-v0.2-cc1200 telelco-v0.2-cc1200/flash-loader \
	telelco-v0.3 telelco-v0.3/flash-loader \
	telelco-v2.0 telelco-v2.0/flash-loader \
	teledongle-v3.0 teledongle-v3.0/flash-loader \
	teleballoon-v2.0 \
	telebt-v3.0 telebt-v3.0/flash-loader \
	telebt-v4.0 telebt-v4.0/flash-loader \
	telelcotwo-v0.1 telelcotwo-v0.1/flash-loader \
	telefireone-v1.0 telefireone-v1.0/flash-loader \
	telefiretwo-v0.1 telefiretwo-v0.1/flash-loader \
	telefireeight-v1.0 telefireeight-v1.0/flash-loader \
	telefireeight-v2.0 telefireeight-v2.0/flash-loader 

ARMM0DIRS=\
	easymini-v1.0 easymini-v1.0/flash-loader \
	chaoskey-v1.0 chaoskey-v1.0/flash-loader \
	telemini-v3.0 telemini-v3.0/flash-loader \
	easymini-v2.0 easymini-v2.0/flash-loader \
	easymini-v3.0 easymini-v3.0/flash-loader \
	micropeak-v2.0

AVRDIRS=\
	micropeak microkite microsplash

SUBDIRS=

ifeq ($(strip $(HAVE_ARM_M3_CC)),yes)
SUBDIRS+=$(ARMM3DIRS)
foo=bar
endif

ifeq ($(strip $(HAVE_ARM_M0_CC)),yes)
SUBDIRS+=$(ARMM0DIRS)
baz=bletch
endif

ifeq ($(strip $(HAVE_AVR_CC)),yes)
SUBDIRS += $(AVRDIRS)
endif

ALLDIRS=$(ARMM3DIRS) $(ARMM0DIRS) $(AVRDIRS)

all: all-local all-recursive

RECURSIVE_TARGETS = all-recursive install-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(SUBDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

ALL_RECURSIVE_TARGETS = clean-recursive

$(ALL_RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(ALLDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

distclean:	clean

clean: clean-local clean-recursive

install: install-recursive

uninstall:

all-recursive: all-local

all-local: altitude.h altitude-pa.h altitude-pa-small.h ao_kalman.h ao_whiten.h $(PDCLIB)

altitude.h: make-altitude
	nickle $< > $@

altitude-pa.h: make-altitude-pa
	nickle $< > $@

altitude-pa-small.h: make-altitude-pa
	nickle $< --sample 3 > $@

ao_kalman.h: make-kalman kalman.5c kalman_micro.5c kalman_filter.5c load_csv.5c matrix.5c
	bash $< kalman > $@

ao_whiten.h: make-whiten
	nickle $< > $@

clean-local: $(CLEAN_PDCLIB)
	rm -f altitude.h ao_kalman.h

=== src/easymotor-v3/Makefile ===
#
# AltOS build
#
#

include ../lpc/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_adxl375.h \
	lpc.h

#
# Common AltOS sources
#

ALTOS_SRC = \
	ao_interrupt.c \
	ao_boot_chain.c \
	ao_romconfig.c \
	ao_product.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_report.c \
	ao_flight.c \
	ao_kalman.c \
	ao_sample.c \
	ao_data.c \
	ao_convert_volt.c \
	ao_task.c \
	ao_log.c \
	ao_log_motor.c \
	ao_cmd.c \
	ao_config.c \
	ao_timer_lpc.c \
	ao_exti_lpc.c \
	ao_spi_lpc.c \
	ao_adc_lpc.c \
	ao_usb_lpc.c \
	ao_m25.c \
	ao_adxl375.c \
	ao_beep_lpc.c

PRODUCT=EasyMotor-v3
PRODUCT_DEF=-DEASYMOTOR_V_3
IDPRODUCT=0x002c

CFLAGS = $(PRODUCT_DEF) $(LPC_CFLAGS)

PROGNAME=easymotor-v3
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_easymotor.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== debian/changelog ===
altos (1.9.12-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * need to save .bin for TeleGPS v2.0
  * first cut at EasyMotor v3 support
  * a few config tweaks
  * get ram usage under control, etc
  * Revert "adxl375: Disable spi duplex"
  * fix SPI index definition
  * recognize EasyMotor-v3 too
  * fix mailing list reference to use mailman3 path
  * doc: additional improvements to motortest manual
  * doc: include reference to Loki Research closures in motortest document
  * fat: sign Windows installers with our new code signing certificate
  * update Releasing to include reference to jsign as a release dependency
  * updating changelog for 1.9.12 release

  [ Keith Packard ]
  * lpc: Make beeper timer configurable
  * easymotor-v3: Configure beeper
  * lpc: Stick magic value at 0x2fc to let us use PIO0_1
  * lpc: Fix name of timer ioconf for pio0_1
  * lpc: Fix name of timer ioconf constants
  * lpc: Fixes for timer configuration
  * easymotor-v3: enable adxl debugging
  * adxl375: Disable spi duplex
  * lpc: Attempt to make beeper generate correct tone
  * altos: Fix ADXL375 SPI mode definitions and usage
  * Disable adxl debug, set long delay
  * reduce adxl speed to 100kHz
  * lpc: Add SPI mode support. Use for ADXL375 on easymotor
  * easymotor-v3: Increase ADXL spi speed back to normal, remove delay
  * lpc: Shuffle more bits around for flash loader
  * altos: Add EasyMotor-v3.0 to regular builds
  * ao-eeprom: Add EasyMotor decode
  * altoslib: Replace EasyMotor v2 code with v3
  * ao-eeprom: Add easy motor support
  * altos: Document easymotor record length
  * doc: Update call sign
  * ao-elftohex: Allow multiple elf files to be merged together
  * easymini-v3.0: Create combined .ihx file for testing
  * ao-elftohex: Add '-n' option to elide symbol table from output
  * easymini: Elide symbols from combined .ihx file
  * altos: Increase AES IV buffer to hold maximum AES state
  * altos: Allow setting telemetry interval to zero without crashing
  * Add EasyMini v3.0 firmware to release
  * ao-eeprom: Handle merge conflict from easymotor-v3 branch
  * easymotor-v3: Fix beeper config
  * altos: Allow 'c a 0' without Syntax Error
  * altoslib: Map log format back to USB device id
  * altosuilib: Limit EasyMotor graphs to motor pressure and accel by default
  * doc: Add specs for EasyMini v3 and EasyMotor v3
  * doc: Add preliminary 1.9.12 release notes
  * Add EasyMotor v3 firmware to release
  * altosui: Ship motortest.pdf with packaged builds
  * altosuilib: Remove some debug printfs
  * Auto-detect windows signing stuff
  * Version 1.9.12

 -- Bdale Garbee <bdale@gag.com>  Fri, 28 Oct 2022 23:12:21 -0600

altos (1.9.11-2) unstable; urgency=medium

  * cherry pick patch from master that increases AES IV buffer to hold 
    maximum AES state, closes: #1022301

 -- Bdale Garbee <bdale@gag.com>  Mon, 24 Oct 2022 10:02:35 -0600

## altos 1.9.13

=== src/Makefile ===
--- 
+++ 
@@ -27,6 +27,7 @@
 	telemega-v3.0 telemega-v3.0/flash-loader \
 	telemega-v4.0 telemega-v4.0/flash-loader \
 	telemega-v5.0 telemega-v5.0/flash-loader \
+	telemega-v6.0 telemega-v6.0/flash-loader \
 	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
 	telemetrum-v3.0 telemetrum-v3.0/flash-loader \
 	telegps-v0.3 telegps-v0.3/flash-loader \

=== debian/changelog ===
altos (1.9.13-1) unstable; urgency=medium

  [ Keith Packard ]
  * altos: Switch LED pin number to 8 bits
  * altos: Use -ffunction-sections -fdata-sections
  * altos: Add SAMD21 bits
  * altos: Add sample samd21 application for snekboard
  * ao-tools: Add ao-flash-samd21 script
  * altos/samd21: Add register definitions
  * altos/samd21: Get USB driver working in AltOS
  * altos/samd21: Automatically erase flash when writing
  * altos/snekboard: Indicate that USB is used for stdio
  * altos: Switch LED pin number to 8 bits
  * altos: Use --gc-sections
  * altos: Add SAMD21 bits
  * altos: Add sample samd21 application for snekboard
  * ao-tools: Add ao-flash-samd21 script
  * altos/samd21: Add register definitions
  * altos/samd21: Get USB driver working in AltOS
  * altos/samd21: Automatically erase flash when writing
  * altos/snekboard: Indicate that USB is used for stdio
  * Add option to beep max height in feet rather than just meters
  * altos: Get SAMD21 SPI driver working in non-DMA mode
  * snekboard: Add samd21 SPI test function
  * This is what I'm using locally for flashing samd21 parts
  * samd21: Configure ROM/RAM values per device and provide linker scripts for each
  * altos: Add metro-m0 port for SAMD21G18 testing
  * samd21: Fix up DMA driver
  * samd21: Avoid divides in boot loader
  * samd21: Fix value defines to be unsigned long
  * samd21: Use DMA for SPI send
  * snekboard: Need DMA for SPI now.
  * samd21: Macro-ize the DMA register settings a bit
  * samd21: Add ability to use arbitrary pin configs with SPI
  * metro-m0: Configure on-board SPI flash part
  * altos/ms5607: Use ao_gpio_set instead of stm_gpio_set
  * samd21: Get ADC code compiling
  * samd21: Add SPI configurations used by TM v4.0
  * samd21: Get serial driver building
  * altos/telemetrum-v4.0: Almost building
  * samd21: Shrink default stack to 512 bytes
  * samd21: Stub out exti code
  * samd21: Stub out beep code
  * altos/telemetrum-v4.0: It links
  * samd21: Wire up pin interrupts
  * metro-m0: Demo pin interrupts
  * samd21: Get beep code working
  * samd21: Move DMA channel defs to ao_dma_samd21.h
  * samd21: Hook up AltOS timer functionality
  * samd21: Hook up AltOS style ADC
  * metro-m0: Hook up ADC sample from A pins
  * telemetrum-v4.0: Add beeper and fix ADC defs
  * telemetrum-v4.0: Remove unused file
  * drivers/ublox: Clean up some debug mode code
  * samd21: Leave serial RX interrupts enabled
  * metro-m0: Add GPS support
  * telemetrum-v4.0: Set USE_SERIAL_1_STDIN to 0
  * telegps: Copy altosui 'beep feet' bits to telegps
  * altos/ms5607: Use duplex for fetching data
  * samd21: PA20 maps to SERCOM3.2 not SERCOM3.3
  * samd21: Limit SPI baud value to 1
  * samd21: Restore pin cfg when exti is disabled
  * samd21: AO_SPI_0_PA04_PA05_PA06 is FUNC_D
  * fixup for exti restore
  * telemetrum-v4.0: MS5607 doesn't share SPI controller
  * telemetrum-v4.0: Correct beeper configuration
  * altos/cc1200: Simplify interrupt handling
  * altos: Avoid modulus in task queue on parts without idiv
  * samd21: Save interrupt pin status before enabling interrupts
  * attiny, stm32l0: Note that these chips don't support spi duplex
  * altos: Add ao_gps_utc_tick
  * altos/ms5607: Fixup ms5607 changes for other chips
  * altos: Make sure APRS packets are reasonably separated
  * altos: Enable telemetrum telemetry for telemetrum v4.0
  * altoslib: Handle TeleMetrum v4.0 in idle mode
  * Add TeleMetrum v4.0 to release files
  * ao-tools/ao-eeprom: Add support for TeleMega v5.0
  * altoslib: Add notes about updating ao-eeprom for new product
  * altos: Add timeout for MS5607 ADC conversion
  * easymotor-v3.0: Use motor pressure to trigger data logging
  * easymotor-v3.0: Clean up build bits
  * altos/stm: Add ao_spi_put_pins for MS5607 driver
  * altos/stmf0: Add ao_spi_put_pins for MS5067 driver
  * altos: Add timeout in MS5607 get_sample code
  * drivers: Add BMI088 driver
  * altos: Add BMI088 test framework using Nucleo32 board for stm32f042
  * altos: Add TeleMega v6.0
  * doc: Update docs for asciidoctor-pdf version 2.x
  * src/drivers: Ignore printf warnings in ao_aprs.c
  * drivers: Add AO_LOG_NORMALIZED support to BMI088 command
  * altos: Split AO_LOG_NORMALIZED support out in telemetry code
  * ao-tools: Fix buffer overflow in lib/ao-hex.c
  * ao-tools: Update ao-eeprom for TeleMega v6
  * altoslib: Add TeleMega v6 support
  * altos/telelco: Add some debug aids for TeleLCO event stuff
  * easymotor-v3: Fix pressure to adc conversion to use reference voltage
  * altos/easymotor: Move pressure conversion code to ao_motor_flight.c
  * altos: Add makefiles for telemega v6
  * doc: Add release notes for 1.9.13
  * doc: Update copyright year to 2023
  * Version 1.9.13
  * Disable TM v4.0 firmware for 1.9.13
  * doc: Add release notes for 1.9.13
  * doc: Update copyright year to 2023
  * Version 1.9.13

  [ Bdale Garbee ]
  * first stab at support for TeleMetrum v4.0
  * update Releasing with tweaks made during 1.9.12 release process
  * easymini v3.0 production scripts working
  * EasyMotor v3 production script working, sans pressure input test
  * ao-tools: don't do 'm 0' after 'E 0' since EasyMotor doesn't support it
  * update Releasing to include EasyMini v3.0 loader
  * ao-tools: new ao-test-pressure utility for bench testing EasyMotor
  * ao-bringup: final production test script for EasyMotor v3
  * ao-tools: increase robustness of turnon_easymotor
  * TeleMetrum v4.0 work in progress
  * altosui: force Locale.ROOT during CSV export to avoid commas in decimals
  * ao-tools: return ao-flash-lpc operaton to "full speed"
  * doc: add a warning to TeleLaunch docs about siren volume levels
  * doc: add a link to a reference on ARES/RACES use of PowerPole connectors
  * doc: update EasyMotor behavior description for firmware 1.9.13 and later
  * doc: update EasyMotor behavior description for firmware 1.9.13 and later
  * releasing 1.9.13



## altos 1.9.14

=== debian/changelog ===
altos (1.9.14-1) unstable; urgency=medium

  [ Keith Packard ]
  * drivers/cc1200: Don't disable cc1200 interrupts ever
  * altos/telefiretwo-v0.2: Get things building again
  * altos/drivers: Use spi duplex to fetch register values
  * altos/drivers: Increase LCO receive timeout to 20ms
  * doc: Release notes for 1.9.14
  * Version 1.9.14

  [ Bdale Garbee ]
  * ChangeLog for releas 1.9.14

 -- Bdale Garbee <bdale@gag.com>  Thu, 02 Feb 2023 12:55:20 -0700

altos (1.9.13-2) unstable; urgency=medium

  * drop the suggests on slim | gdm, it's just no useful

 -- Bdale Garbee <bdale@gag.com>  Sun, 29 Jan 2023 15:11:04 -0700

## altos 1.9.15

=== src/Makefile ===
--- 
+++ 
@@ -50,6 +50,7 @@
 ARMM0DIRS=\
 	easymini-v1.0 easymini-v1.0/flash-loader \
 	chaoskey-v1.0 chaoskey-v1.0/flash-loader \
+	telemetrum-v4.0 telemetrum-v4.0/flash-loader \
 	telemini-v3.0 telemini-v3.0/flash-loader \
 	easymini-v2.0 easymini-v2.0/flash-loader \
 	easymini-v3.0 easymini-v3.0/flash-loader \

=== debian/changelog ===
altos (1.9.15-1) unstable; urgency=medium

  [ Keith Packard ]
  * altos: Add .gitignore for telemega v6.0
  * altos/telemega-v6: Remove beep freq defs and use defaults
  * altos/telemega-v6.0: bmi088 axes were wrong
  * altoslib: Hide internals of AltosIMU
  * altos: Fix TMega v6.0 and v5.0 IMU axes
  * doc: Add initial 1.9.15 release notes
  * doc: Add HW specs for TeleMega v6.0
  * Add TeleMega v6.0 firmware to release
  * Add TeleMetrum v4.0 firmware to releases
  * altos/telemetrum-v4.0: Add .gitignore
  * doc: Add TeleMetrum v4.0 to specs and 1.9.15 release notes
  * ao-tools/ao-flash: Use 'program' instead of 'flash' for samd21
  * Version 1.9.15

  [ Bdale Garbee ]
  * altos: add csm84clio-v0.1 firmware
  * altos: re-number csm85clio outputs 0..49 to match schematic and silkscreen
  * ao-bringup: turnon and test scripts for TeleMetrum v4.0 & TeleMega v6.0
  * releasing 1.9.15

 -- Bdale Garbee <bdale@gag.com>  Sun, 19 Feb 2023 18:29:00 -0700

## altos 1.9.16

=== src/Makefile ===
--- 
+++ 
@@ -33,6 +33,7 @@
 	telegps-v0.3 telegps-v0.3/flash-loader \
 	telegps-v1.0 telegps-v1.0/flash-loader \
 	telegps-v2.0 telegps-v2.0/flash-loader \
+	telegps-v3.0 telegps-v3.0/flash-loader \
 	telelco-v0.2 telelco-v0.2/flash-loader \
 	telelco-v0.2-cc1200 telelco-v0.2-cc1200/flash-loader \
 	telelco-v0.3 telelco-v0.3/flash-loader \

=== src/detherm/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	stm32f0.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_timer.c \
	ao_panic.c \
	ao_mutex.c \
	ao_dma_stm.c \
	ao_usb_stm.c \
	ao_spi_stm.c \
	ao_exti_stm.c \
	ao_stdio.c \
	ao_led_stmf0.c \
	ao_log.c \
	ao_log_mini.c \
	ao_sample.c \
	ao_data.c \
	ao_kalman.c \
	ao_flight.c \
	ao_report.c \
	ao_storage.c \
	ao_m25.c \
	ao_romconfig.c \
	ao_boot_chain.c \
	ao_ms5607.c \
	ao_convert_pa.c \
	ao_pwm.c \
	ao_servo.c \
	ao_task.c \
	ao_config.c \
	ao_cmd.c \
	ao_product.c

PRODUCT=Detherm-v1.0
PRODUCT_DEF=-DDETHERM_V_1_0
IDPRODUCT=0x0013

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS)

PROGNAME=detherm-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_detherm.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) -o $@

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/easymini-v1.0/Makefile ===
#
# AltOS build
#
#

include ../lpc/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	lpc.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_boot_chain.c \
	ao_romconfig.c \
	ao_product.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_report.c \
	ao_ignite.c \
	ao_flight.c \
	ao_kalman.c \
	ao_sample.c \
	ao_data.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_task.c \
	ao_log.c \
	ao_log_mini.c \
	ao_cmd.c \
	ao_config.c \
	ao_timer_lpc.c \
	ao_exti_lpc.c \
	ao_usb_lpc.c \
	ao_spi_lpc.c \
	ao_adc_lpc.c \
	ao_beep_lpc.c \
	ao_m25.c \
	ao_ms5607.c

PRODUCT=EasyMini-v1.0
PRODUCT_DEF=-DEASYMINI_V_1_0
IDPRODUCT=0x0026

CFLAGS = $(PRODUCT_DEF) $(LPC_CFLAGS)

PROGNAME=easymini-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx
FLASH_PROG=flash-loader/$(PROGNAME)-altos-flash-$(VERSION).elf
BOTH_HEX=$(PROGNAME)-combined-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_easymini.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX) $(BOTH_HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(BOTH_HEX): $(PROG) $(FLASH_PROG)
	../../ao-tools/ao-elftohex/ao-elftohex -n --output=$@ $(FLASH_PROG) $(PROG)

$(FLASH_PROG): FRC
	+cd flash-loader && make

FRC:

$(OBJ): $(INC)

load: $(PROG)
	lpc-load $(PROG)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== src/micropeak-v2.0/Makefile ===
#
# Tiny AltOS build
#
#

include ../stm32l0/Makefile.defs

PUBLISH_DIR=$(HOME)/altusmetrumllc/Binaries
PUBLISH_HEX=$(PUBLISH_DIR)/$(HEX)

MICRO_SRC=\
	ao_report_micro.c \
	ao_log_micro.c \
	ao_microflight.c \
	ao_microkalman.c

INC=\
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_exti.h \
	ao_ms5607.h \
	ao_log_micro.h \
	ao_micropeak.h \
	ao_lpuart.h \
	altitude-pa.h \
	ao_product.h \
	stm32l0.h

ALTOS_SRC = \
	ao_interrupt.c \
	ao_panic.c \
	ao_micro.c \
	ao_report_micro.c \
	ao_stdio.c \
	ao_notask.c \
	ao_serial_stm.c \
	ao_lpuart_stm.c \
	ao_timer.c \
	ao_spi_stm32l0.c \
	ao_adc_stm32l0.c \
	ao_ms5607.c \
	ao_exti_stm.c \
	ao_convert_pa.c \
	ao_led.c \
	ao_cmd.c \
	ao_product.c \
	ao_romconfig.c \
	ao_flash_stm32l0.c \
	ao_microflight.c \
	ao_log_micro.c \
	ao_microkalman.c

IDPRODUCT=0x14
PRODUCT=MicroPeak-v2.0
PRODUCT_DEF=-DMICROPEAK

CFLAGS = $(PRODUCT_DEF) $(STML0_CFLAGS) -Wl,--gc-sections -ffunction-sections -fdata-sections

PROGNAME=micropeak-v2.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

LDFLAGS=-nostartfiles $(CFLAGS) -L$(TOPDIR)/stm32l0 -Taltos.ld -n

$(PROG): Makefile $(OBJ) micropeak.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS) -Wl,-Map=$(PROGNAME)-$(VERSION).map

distclean:	clean

clean:
	rm -f *.o *.elf *.ihx *.map
	rm -f ao_product.h

publish: $(PUBLISH_HEX)

$(PUBLISH_HEX): $(HEX)
	cp -a $(HEX) $@

install:

uninstall:

$(OBJ): $(INC)

=== src/telemega-v3.0/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_companion.h \
	ao_data.h \
	ao_sample.h \
	ao_pins.h \
	altitude-pa.h \
	ao_kalman.h \
	ao_product.h \
	ao_ms5607.h \
	ao_mpu9250.h \
	ao_mma655x.h \
	ao_cc1200_CC1200.h \
	ao_profile.h \
	ao_task.h \
	ao_whiten.h \
	ao_sample_profile.h \
	ao_quaternion.h \
	ao_mpu.h \
	stm32l.h \
	ao_ms5607_convert.c \
	Makefile

#
# Common AltOS sources
#

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led_stm.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_gps_ublox.c \
	ao_gps_show.c \
	ao_gps_report_mega.c \
	ao_ignite.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_cc1200.c \
	ao_data.c \
	ao_ms5607.c \
	ao_mma655x.c \
	ao_adc_stm.c \
	ao_beep_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_report.c \
	ao_i2c_stm.c \
	ao_mpu9250.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_log.c \
	ao_log_mega.c \
	ao_sample.c \
	ao_kalman.c \
	ao_flight.c \
	ao_telemetry.c \
	ao_packet_slave.c \
	ao_packet.c \
	ao_companion.c \
	ao_pyro.c \
	ao_aprs.c \
	ao_pwm_stm.c \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=TeleMega-v3.0
PRODUCT_DEF=-DTELEMEGA
IDPRODUCT=0x0023

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF)

PROGNAME=telemega-v3.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_telemega.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== src/telemega-v5.0/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_companion.h \
	ao_data.h \
	ao_sample.h \
	ao_pins.h \
	altitude-pa.h \
	ao_kalman.h \
	ao_product.h \
	ao_ms5607.h \
	ao_mpu6000.h \
	ao_mmc5983.h \
	ao_adxl375.h \
	ao_cc1200_CC1200.h \
	ao_profile.h \
	ao_task.h \
	ao_whiten.h \
	ao_sample_profile.h \
	ao_quaternion.h \
	ao_mpu.h \
	stm32l.h \
	ao_ms5607_convert.c \
	Makefile

#
# Common AltOS sources
#

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

# Bit-bang MMC5983 chip needs this
#	ao_i2c_bit.c

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led_stm.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_gps_ublox.c \
	ao_gps_show.c \
	ao_gps_report_mega.c \
	ao_ignite.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_cc1200.c \
	ao_data.c \
	ao_ms5607.c \
	ao_adxl375.c \
	ao_adc_stm.c \
	ao_beep_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_report.c \
	ao_mpu6000.c \
	ao_mmc5983.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_log.c \
	ao_log_mega.c \
	ao_sample.c \
	ao_kalman.c \
	ao_flight.c \
	ao_telemetry.c \
	ao_packet_slave.c \
	ao_packet.c \
	ao_companion.c \
	ao_pyro.c \
	ao_aprs.c \
	ao_pwm_stm.c \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=TeleMega-v5.0
PRODUCT_DEF=-DTELEMEGA
IDPRODUCT=0x0023

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF)

PROGNAME=telemega-v5.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_telemega.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== src/telemega-v6.0/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_companion.h \
	ao_data.h \
	ao_sample.h \
	ao_pins.h \
	altitude-pa.h \
	ao_kalman.h \
	ao_product.h \
	ao_ms5607.h \
	ao_bmi088.h \
	ao_mmc5983.h \
	ao_adxl375.h \
	ao_cc1200_CC1200.h \
	ao_profile.h \
	ao_task.h \
	ao_whiten.h \
	ao_sample_profile.h \
	ao_quaternion.h \
	ao_mpu.h \
	stm32l.h \
	ao_ms5607_convert.c \
	Makefile

#
# Common AltOS sources
#

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#SAMPLE_PROFILE=ao_sample_profile.c \
#	ao_sample_profile_timer.c
#SAMPLE_PROFILE_DEF=-DHAS_SAMPLE_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_led_stm.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_gps_ublox.c \
	ao_gps_show.c \
	ao_gps_report_mega.c \
	ao_ignite.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_cc1200.c \
	ao_data.c \
	ao_ms5607.c \
	ao_adxl375.c \
	ao_adc_stm.c \
	ao_beep_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_report.c \
	ao_bmi088.c \
	ao_mmc5983.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_log.c \
	ao_log_mega.c \
	ao_sample.c \
	ao_kalman.c \
	ao_flight.c \
	ao_telemetry.c \
	ao_packet_slave.c \
	ao_packet.c \
	ao_companion.c \
	ao_pyro.c \
	ao_aprs.c \
	ao_pwm_stm.c \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=TeleMega-v6.0
PRODUCT_DEF=-DTELEMEGA
IDPRODUCT=0x0023

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF)

PROGNAME=telemega-v6.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_telemega.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== src/telestatic-v3.0/Makefile ===
#
# TeleStatic build file
#

include ../stm/Makefile.defs

INC = \
	ao.h \
	ao_pins.h \
	ao_log.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pad.h \
	ao_product.h \
	ao_radio_spi.h \
	ao_radio_cmac.h \
	ao_cc1200_CC1200.h \
	ao_cc1200.h \
	stm32l.h
#
# Common AltOS sources
#

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_adc_stm.c \
	ao_data.c \
	ao_config.c \
	ao_task.c \
	ao_led.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_freq.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_eeprom_stm.c \
	ao_storage.c \
	ao_m25.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_cc1200.c \
	ao_radio_cmac.c \
	ao_aes.c \
	ao_aes_tables.c \
	ao_pad.c \
	ao_radio_cmac_cmd.c \
	ao_log.c \
	ao_log_telestatic.c \
	ao_max6691.c

PRODUCT_SRC = \
	ao_telestatic.c

PRODUCT=TeleStatic-v3.0
PRODUCT_DEF=-DTELESTATIC_V_3_0
IDPRODUCT=0x000f

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF)

PROGNAME = telestatic-v3.0
PROG = $(PROGNAME)-$(VERSION).elf
HEX = $(PROGNAME)-$(VERSION).ihx

SRC = $(ALTOS_SRC) $(PRODUCT_SRC)
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx $(PROGNAME)-*.map
	rm -f ao_product.h

install:

uninstall:

=== ao-tools/target/blink/Makefile ===
CC=sdcc
NO_OPT=--nogcse --noinvariant --noinduction --nojtbound --noloopreverse \
	--nolabelopt --nooverlay --peep-asm
DEBUG=--debug

CFLAGS=--model-large $(DEBUG) --less-pedantic \
	--no-peep --int-long-reent --float-reent \
	--data-loc 0x30

LDFLAGS=--out-fmt-ihx
LDFLAGS_RAM=$(LDFLAGS) --code-loc 0xf000 --xram-loc 0xf400 --xram-size 1024

LDFLAGS_FLASH=$(LDFLAGS) --code-loc 0x0000 --xram-loc 0xf000 --xram-size 1024

SRC=blink.c
ADB=$(SRC:.c=.adb)
ASM=$(SRC:.c=.asm)
LNK=$(SRC:.c=.lnk)
LST=$(SRC:.c=.lst)
REL=$(SRC:.c=.rel)
RST=$(SRC:.c=.rst)
SYM=$(SRC:.c=.sym)

PROGS=blink-flash.ihx blink-ram.ihx
PCDB=$(PROGS:.ihx=.cdb)
PLNK=$(PROGS:.ihx=.lnk)
PMAP=$(PROGS:.ihx=.map)
PMEM=$(PROGS:.ihx=.mem)
PAOM=$(PROGS:.ihx=)

%.rel : %.c
	$(CC) -c $(CFLAGS) -o$*.rel $<

all: $(PROGS)

blink-ram.ihx: $(REL) Makefile
	$(CC) $(LDFLAGS_RAM) $(CFLAGS) -o blink-ram.ihx $(REL)
	$(CC) $(LDFLAGS_FLASH) $(CFLAGS) -o blink-flash.ihx $(REL)

blink-flash.ihx: blink-ram.ihx

clean:
	rm -f $(ADB) $(ASM) $(LNK) $(LST) $(REL) $(RST) $(SYM)
	rm -f $(PROGS) $(PCDB) $(PLNK) $(PMAP) $(PMEM) $(PAOM)

install:

=== src/detherm/flash-loader/Makefile ===
#
# AltOS flash loader build
#
#

TOPDIR=../..
HARDWARE=detherm-v1.0
include $(TOPDIR)/stmf0/Makefile-flash.defs

=== src/easymini-v1.0/flash-loader/Makefile ===
#
# AltOS flash loader build
#
#

TOPDIR=../..
HARDWARE=easymini-v1.0
include $(TOPDIR)/lpc/Makefile-flash.defs

=== src/stm-demo/flash-loader/Makefile ===
#
# AltOS flash loader build
#
#

TOPDIR=../..
HARDWARE=stm-demo
include $(TOPDIR)/stm/Makefile-flash.defs

=== debian/changelog ===
altos (1.9.16-2) unstable; urgency=medium

  * fix path systemd service file for mapd is deliverd to, closes: #1036022

 -- Bdale Garbee <bdale@gag.com>  Sun, 14 May 2023 10:48:57 -0700

altos (1.9.16-1) unstable; urgency=medium

  [ Keith Packard ]
  * altos: Fill in more of the draw code
  * altos/draw: Add poly fill function
  * altos/draw: Only cover ASCII
  * altos/draw: Make test drawing app emulate TeleLCO
  * altos/draw: Use float for polygon coords
  * altos/draw: Add logo
  * altos/draw: Add more fonts
  * altos/draw: Move font files to subdirectory
  * altos/draw: Add monospaced font
  * altos/draw: Convert draw test framework to modern C
  * altos/draw: Add transforms to polygon code
  * altos/draw: Add NotoMono font
  * altos/draw: Rearrange sample LCO screen in draw-test
  * altos/draw: use --gc-sections in demo program
  * altos/draw: Mock up TeleLCO boot sequence
  * altos/draw: Rename test app to 'lco-test'
  * altos/draw: Add validation for line drawing
  * altos/draw: Check for horiz/vert line when clipping
  * altos/draw: Fix clipping far line end
  * altos/draw: Inline span fill for polygons
  * altos/draw: Split out draw test scaffolding from lco-test.c
  * altos/draw: Add line test app
  * altos/draw: Use fewer fonts in lco sample
  * altos/draw: hand-edit 64-pixel 3/5 to avoid jank
  * altos/draw: Add damage tracking
  * altos/draw: Add vera sans fonts
  * altos/draw: Use <> for include files
  * altos/draw: Use bitstream fonts for LCO demo
  * altos/draw: Use damage for lco demo
  * altos: Allow ports to use type other than 'void *' for gpio block
  * altos/lpc: Support UART on pio1_13/pio1_14
  * altos: Add TeleGPS v3.0 support
  * altos: Build TeleGPS v3.0 by default
  * altos/lpc: Add support for eeprom on 2x/3x chips
  * altos/telegps-v3.0: Use eeprom for config
  * altos/lpc: Validate UART pin config
  * altos/lpcxpresso: Update for 11u24 board
  * altos/telegps-v3.0: Fix SPI bus usage
  * altoslib: Support TeleGPS v3 monitor idle
  * altoslib: Parse more GPS monitor data
  * altos/drivers: Support uBlox Max 10 chips
  * altos: Dump GPS dop/course data from 'g' command
  * altos/telegps-v3.0: Use new MAX 10 support in uBlox driver
  * altos: Make sure storage is setup before starting log
  * altos/lpc: Support 6k ram targets
  * altos/telegps-v3.0: Use all 6kB of available ram
  * altos/telegps-v3.0: Get LED blinking when GPS locks
  * telegps: Add unit setting to device configuration dialog
  * altos/stmf0: Remove some incorrect defines in stm32f0.h
  * altos/stm32f04x: Smite the OPL_LAUNCH bit to reset boot config
  * Version 1.9.15.1
  * doc: Add 1.9.16 release notes
  * Add TeleGPS v3.0 firmware
  * altosdroid: Deal with Google requiring API version 31
  * Version 1.9.16

  [ Bdale Garbee ]
  * add production scripts for TeleGPS v3.0
  * update TeleGPS v3.0 production script to flash correct firmware versions
  * updte ChangeLog for 1.9.16 release

 -- Bdale Garbee <bdale@gag.com>  Thu, 27 Apr 2023 23:55:05 -0600

=== debian/control ===
Source: altos
Section: electronics
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Uploaders: Keith Packard <keithp@keithp.com>
Build-Depends: asciidoctor,
               ruby-asciidoctor-pdf,
               strip-nondeterminism,
               autoconf,
               automake,
               debhelper (>= 13),
               default-jdk,
	       faketime,
               freetts,
               gawk,
               gcc-arm-none-eabi,
               picolibc-arm-none-eabi,
               graphicsmagick | imagemagick,
               graphviz,
               icnsutils,
               icoutils,
               libbluetooth-dev,
               libelf-dev,
	       libjansson-dev,
	       libjson-c-dev,
               gtk-update-icon-cache,
               libjfreechart-java,
               libreadline-dev,
               librsvg2-bin,
               libtool,
               libusb-1.0-0-dev,
               netpbm,
               nickle,
	       cairo-5c,
               pkg-config,
               shared-mime-info,
               swig
Standards-Version: 4.6.0
Homepage: http://altusmetrum.org/AltOS
Vcs-Git: git://git.gag.com/fw/altos -b debian
Vcs-Browser: http://git.gag.com/?p=fw/altos

Package: altos
Architecture: any
Depends: default-jre | java2-runtime,
         freetts,
         libjfreechart-java,
         nickle,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: altusmetrum-themes, slim-altusmetrum
Conflicts: altusmetrum-themes, slim-altusmetrum
Description: Altus Metrum firmware and utilities
 Firmware and utilities needed to support high power model rocketry products
 from Altus Metrum, including TeleMetrum, TeleMini, and TeleDongle.
 .
 See http://altusmetrum.org/ for more information.
